/*
 * Desenha um objeto em MRUV, os cliques do mouse incrementam o tempo.
 */



import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.*;
import java.lang.Math;



class corpo {

    double forca = 8;
    double massa = 4;
    double aceleracao = 0;
    double velocidade_inicial = 0;
    double velocidade = 0;
    double posicao_inicial = 0;
    double posicao = 0;

    double pos_x = 0;
    double pos_y = 0;

    public void def_pos (double x, double y) {
	pos_x = x;
	pos_y = y;
    }

    public void altera_estado (double tempo) {
	aceleracao = forca / massa;
	velocidade = aceleracao * tempo + velocidade_inicial;
	posicao = aceleracao * Math.pow (tempo, 2) / 2 + velocidade_inicial * tempo + posicao_inicial;
	pos_x = posicao;
    }

    public void exibe (Graphics gr) {
	int x = (int) pos_x;
	int y = (int) pos_y;
	gr.drawLine (x-2, y-2, x+2, y+2);
	gr.drawLine (x+2, y-2, x-2, y+2);
    }
}



public class cine_0_6 extends java.applet.Applet implements MouseListener {

    double tempo;

    corpo p;
    boolean ini_p;

    public void init () {
	p = new corpo ();
	p.def_pos (0, 50);
	ini_p = true;
	tempo = 0;
        addMouseListener (this);
    }

    public void destroy () {
	removeMouseListener (this);
    }

    public void mousePressed (MouseEvent e) {
        e.consume ();
	tempo += 1;
	p.altera_estado (tempo);
	repaint ();
    }

    public void mouseReleased (MouseEvent e) {
    }

    public void mouseEntered (MouseEvent e) {
    }

    public void mouseExited (MouseEvent e) {
    }

    public void mouseClicked (MouseEvent e) {
    }

    public void paint (Graphics g) {
	g.drawLine (0, 0, 0, 99);
	g.drawLine (0, 0, 99, 0);
	g.drawLine (99, 0, 99, 99);
	g.drawLine (0, 99, 99, 99);
	g.setColor(Color.white);
	g.fillRect (0, 0, 99, 99);
	g.setColor(Color.red);
	p.exibe (g);
    }
}
