/*
 * Desenha um objeto em MRUV, os cliques do mouse incrementam o tempo.
 */



import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.*;
import java.lang.*;



class corpo {



    double m_pos_x [] = new double [100];
    double m_pos_y [] = new double [100];
    int m_num_pos = 0;



    public void inicia (double x, double y) {
	m_num_pos = 0;
	def_pos (x, y);
    }



    public void def_pos (double x, double y) {
	m_pos_x [m_num_pos] = x;
	m_pos_y [m_num_pos] = y;
	m_num_pos ++;
	if (m_num_pos >= 100) m_num_pos = 0;
    }



    public void exibe (Graphics gr) {
	for (int c = 0; c < m_num_pos; c++) {
	    int x = (int) m_pos_x [c];
	    int y = (int) m_pos_y [c];
	    if (c == m_num_pos - 1)
		gr.setColor(Color.red);
	    else
		gr.setColor(Color.black);
	    gr.drawLine (x-2, y-2, x+2, y+2);
	    gr.drawLine (x+2, y-2, x-2, y+2);
	}
    }
}



class corpo_fisico extends corpo {



    double forca = 8;
    double massa = 4;
    double aceleracao = 0;
    double velocidade_inicial = 0;
    double velocidade = 0;
    double posicao_inicial = 0;
    double posicao = 0;



    public void altera_estado (double tempo) {
	aceleracao = forca / massa;
	velocidade = aceleracao * tempo + velocidade_inicial;
	posicao = aceleracao * Math.pow (tempo, 2) / 2 + velocidade_inicial * tempo + posicao_inicial;
	double y = 0;
	if (m_num_pos != 0)
	    y = m_pos_y [m_num_pos - 1];
	def_pos (posicao, y);
    }
}



public class cine_0_7 extends java.applet.Applet implements MouseListener {



    double tempo;
    corpo_fisico p;
    boolean ini_p;



    public void init () {
	p = new corpo_fisico ();
	p.inicia (0.0, 50.0);
	ini_p = true;
	tempo = 0;
        addMouseListener (this);
    }



    public void destroy () {
	removeMouseListener (this);
    }



    public void mousePressed (MouseEvent e) {
        e.consume ();
	tempo += 1;
	p.altera_estado (tempo);
	repaint ();
    }



    public void mouseReleased (MouseEvent e) {
    }



    public void mouseEntered (MouseEvent e) {
    }



    public void mouseExited (MouseEvent e) {
    }



    public void mouseClicked (MouseEvent e) {
    }



    public void paint (Graphics g) {
	g.drawLine (0, 0, 0, 99);
	g.drawLine (0, 0, 99, 0);
	g.drawLine (99, 0, 99, 99);
	g.drawLine (0, 99, 99, 99);
	g.setColor(Color.white);
	g.fillRect (0, 0, 99, 99);
	p.exibe (g);
    }



    public String getAppletInfo() {
        return "Desenha um objeto.";
    }
}
